
/**
 * Class Arc. 
 * 
 * @version (a version number or a date)
 *
 * @author Andrea Valente
 * Member of <br><b>T</b>he <b>A</b>vatars <b>G</b>roup
 * <br>sf.net/projects/avatarsdev
 */

package sge;

import java.io.*;
import java.awt.geom.*;

class Arc extends Item
				implements Serializable {
int fromNodeId,toNodeId;
static int CLICKSENSIBILITY=5;

	// Needed for serialization
	Arc(){
		this(0,0);
	}
	
	Arc(int fromNodeId,int toNodeId){
		setFromTo(fromNodeId,toNodeId);
	}
	
	public String
	toString(){
      return "A<"+fromNodeId+","+toNodeId+">";
	}

	public void
	setFromTo(int fromNodeId,int toNodeId){
		this.fromNodeId = fromNodeId;
		this.toNodeId   = toNodeId;
	}
	
	public int
	getFromId(){
		return fromNodeId;
	}

	public int
	getToId(){
		return toNodeId;
	}
	
	// Reimplement it to deal with segments!
	// 1- use a shape to check clicks!!
	public boolean
	isInside(int px,int py,Node fromNode,Node toNode){
		int r=Node.RADIUS;
		int x1=fromNode.getX()+r;
		int y1=fromNode.getY()+r;
		int x2=toNode.getX()+r;
		int y2=toNode.getY()+r;

		return (Line2D.Float.ptLineDist(x1,y1,x2,y2,px,py)<=CLICKSENSIBILITY);
	}
}
	
